@echo off
echo.
echo LADsoft C compiler V 2.36 installation
echo.

if NOT "%1" == "" goto ok

echo.
echo Usage: Install DRIVE:
echo.
goto exit

:ok

echo.
echo This install program installs a version of the LADsoft C compiler
echo that can generate DOS programs.  The directory %1\CC386 will be 
echo created and necessary files will be copied there.
echo.
echo You can read the file 'install.txt' for further information
echo concerning the installation and initial use of the compiler
echo.
echo The following assemblers can be used with this compiler:
echo   NASM  (included)
echo   TASM  (not recommended)
echo.
echo The following linkers can be used with this compiler:
echo   VALX  (included)
echo   TLINK (not recommended)
echo   WLINK
echo.

if "%OS%" == "Windows_NT" goto WinNT

choice /C:NY /N Do you want to continue with the installation?
if ERRORLEVEL == 2 goto install
goto cancel

:WinNT
SET /P VAL="Do you want to continue with the installation (Y/N) :"
if "%VAL%" == "y" goto install
if "%VAL%" == "Y" goto install

echo.
echo Installation canceled
goto exit

:install
set LADSOFT=%1\CC386
echo Now Installing binaries and headers

rem create directory tree and copy files
>nul mkdir %LADSOFT%
>nul mkdir %LADSOFT%\bin
>nul mkdir %LADSOFT%\lib
>nul mkdir %LADSOFT%\lib\startup
>nul mkdir %LADSOFT%\include
>nul mkdir %LADSOFT%\include\sys
>nul mkdir %LADSOFT%\examples
>nul mkdir %LADSOFT%\examples\dos
rem >nul mkdir %LADSOFT%\espanol
>nul mkdir %LADSOFT%\english

>nul copy *.c %LADSOFT%\examples
>nul copy keys.c %LADSOFT%\examples\dos
>nul del  %LADSOFT%\examples\keys.c
>nul copy mouse.c %LADSOFT%\examples\dos
>nul del  %LADSOFT%\examples\mouse.c
>nul copy window.c %LADSOFT%\examples\dos
>nul del  %LADSOFT%\examples\window.c
>nul copy stklen.c %LADSOFT%\examples\dos
>nul del  %LADSOFT%\examples\stklen.c
>nul copy vga.c %LADSOFT%\examples\dos
>nul del  %LADSOFT%\examples\vga.c
>nul copy phone.c %LADSOFT%\examples\dos
>nul del  %LADSOFT%\examples\phone.c
>nul copy example.txt %LADSOFT%\examples
>nul copy example.bat %LADSOFT%\examples
>nul copy makefile %LADSOFT%\examples
>nul copy dos.mak %LADSOFT%\examples\dos
>nul copy dos.bat %LADSOFT%\examples\dos
REM >nul copy 4gstub.exe %LADSOFT%\lib
>nul copy 4gstub.exe %LADSOFT%\lib
>nul copy wdosxle.exe %LADSOFT%\lib
>nul copy stub32a.exe %LADSOFT%\lib
>nul copy zrdx.exe %LADSOFT%\lib
>nul copy zrxsetup.exe %LADSOFT%\lib
>nul copy cwstub.exe %LADSOFT%\lib
>nul copy 4gstubq.exe %LADSOFT%\lib
>nul copy pmodew.exe %LADSOFT%\lib
>nul copy *.obj %LADSOFT%\lib
>nul copy *.lib %LADSOFT%\lib

>nul copy *.h %LADSOFT%\include
>nul del  %LADSOFT%\include\types.h
>nul copy types.h %LADSOFT%\include\sys
>nul del  %LADSOFT%\include\locking.h
>nul copy locking.h %LADSOFT%\include\sys
>nul del  %LADSOFT%\include\stat.h
>nul copy stat.h %LADSOFT%\include\sys
>nul del  %LADSOFT%\include\timeb.h
>nul copy timeb.h %LADSOFT%\include\sys

>nul copy *.exe %LADSOFT%\bin
>nul copy valx.hlp %LADSOFT%\bin

>nul copy valx.hlp %LADSOFT%\english\valx.doc
>nul copy *.lic %LADSOFT%
>nul copy *.txt %LADSOFT%
>nul copy copying %LADSOFT%
>nul del  %LADSOFT%\example.txt
>nul copy *.doc %LADSOFT%\english

>nul copy *.nas %LADSOFT%\lib\startup
>nul copy *.asm %LADSOFT%\lib\startup

>nul copy *.mak %LADSOFT%\bin

>nul copy *.mac %LADSOFT%\bin

rem >nul copy *.sdc %LADSOFT%\espanol\*.doc
rem >nul copy *.stx %LADSOFT%\espanol\*.txt

rem now make the cl386.cfg file
echo Now creating Configuration files
echo -I%%LADSOFT%%\INCLUDE -L%%LADSOFT%%\LIB -e /NASM /VALX /C+d  > %LADSOFT%\bin\cl386.cfg
rem now make the mk386.cfg file
echo -I%%LADSOFT%%\INCLUDE -L%%LADSOFT%%\LIB -$A=NASM -$L=VALX -$M=IMAKE > %LADSOFT%\bin\mk386.cfg
rem now make the cc386 .cfg file
echo -I%%LADSOFT%%\include > %LADSOFT%\bin\cc386.cfg
rem now make the valx .cfg file
echo -L:(%%LADSOFT%%\lib) > %LADSOFT%\bin\valx.cfg

rem now make the standard build file
echo Now creating Build.bat (freeware tools build)
echo @echo off > %LADSOFT%\bin\build.bat
echo cc386 /C+N /A- -I%%LADSOFT%%\INCLUDE %%1.c >> %LADSOFT%\bin\build.bat
echo if NOT ERRORLEVEL == 0 goto exit >> %LADSOFT%\bin\build.bat
echo NASM -fobj %%1.asm >> %LADSOFT%\bin\build.bat
echo if NOT ERRORLEVEL==0 goto exit >> %LADSOFT%\bin\build.bat
echo valx -nci -lx %%LADSOFT%%\LIB\c0dosw.obj %%1.obj,%%1,%%1,%%LADSOFT%%\LIB\CLDOS.LIB >> %LADSOFT%\bin\build.bat
echo :exit >> %LADSOFT%\bin\build.bat

rem now make the pmb.bat file
echo Now creating pmb.bat (BORLAND) build file
echo REM > %LADSOFT%\bin\pmb.bat
echo REM WARNING!!! >> %LADSOFT%\bin\pmb.bat
echo REM >> %LADSOFT%\bin\pmb.bat
echo REM Borland tools may add bugs to your code >> %LADSOFT%\bin\pmb.bat
echo REM Use them at your own risk >> %LADSOFT%\bin\pmb.bat
echo REM >> %LADSOFT%\bin\pmb.bat
echo @echo off >> %LADSOFT%\bin\pmb.bat
echo cc386 /S -A- -I%%LADSOFT%%\INCLUDE %%1.c >> %LADSOFT%\bin\pmb.bat
echo if NOT ERRORLEVEL == 0 goto exit >> %LADSOFT%\bin\pmb.bat
echo TASM /ml /m2 %%1.asm >> %LADSOFT%\bin\pmb.bat
echo if NOT ERRORLEVEL==0 goto exit >> %LADSOFT%\bin\pmb.bat
echo TLINK /3/c %%LADSOFT%%\LIB\c0dos.obj %%1.obj,%%1,%%1,%%LADSOFT%%\LIB\CLDOS.LIB >> %LADSOFT%\bin\pmb.bat
echo :exit >> %LADSOFT%\bin\pmb.bat

rem now make the pmw.bat file
echo Now creating pmw.bat and pmw.lnk (WATCOM) build files
echo @echo off  > %LADSOFT%\bin\pmw.bat
echo cc386 /S /A- /I%%LADSOFT%%\INCLUDE %%1.c >> %LADSOFT%\bin\pmw.bat
echo if NOT ERRORLEVEL == 0 goto exit >> %LADSOFT%\bin\pmw.bat
echo NASM -fobj %%1.asm >> %LADSOFT%\bin\pmw.bat
echo if NOT ERRORLEVEL==0 goto exit >> %LADSOFT%\bin\pmw.bat
echo WLINK debug @%%LADSOFT%%\bin\pmw.lnk NAME %%1 FILE %%1 >> %LADSOFT%\bin\pmw.bat
echo :exit >> %LADSOFT%\bin\pmw.bat

rem now make the pmw.lnk linker file
echo option osname='CC386'> %LADSOFT%\bin\pmw.lnk
echo op stub=%%LADSOFT%%\lib\pmodew.exe >> %LADSOFT%\bin\pmw.lnk
echo op symf >> %LADSOFT%\bin\pmw.lnk
echo op nod >> %LADSOFT%\bin\pmw.lnk
echo format os2 le >> %LADSOFT%\bin\pmw.lnk
echo file %%LADSOFT%%\lib\c0dosw.obj >> %LADSOFT%\bin\pmw.lnk
echo library %%LADSOFT%%\lib\cldos.lib >> %LADSOFT%\bin\pmw.lnk

echo.
echo %LADSOFT%\BIN must be added to the path.
echo.
if "%OS%" == "Windows_NT" goto WinNT2

choice /C:NY /N Do you want install to modify your autoexec.bat?
if ERRORLEVEL == 2 goto dobat
goto baterr

:WinNT2
SET /P VAL="Do you want install to modify the path in the registry (Y/N) :"
if "%VAL%" == "Y" goto dobat
if "%VAL%" == "y" goto dobat

:baterr
echo.
echo This package is NOT completely installed.  You MUST add the following
echo commands to AUTOEXEC.BAT (or the registry, on Windows NT)
echo.
echo SET PATH=%%PATH%%;%LADSOFT%\BIN
echo SET LADSOFT=%LADSOFT%
echo.
goto nobat

:dobat
echo.
echo Modifying AUTOEXEC.BAT
echo.

if "%OS%" == "Windows_NT" goto winnt3

echo REM>c:\$$temp$$.bat
echo REM added by LADSoft C compiler>>c:\$$temp$$.bat
echo REM>>c:\$$temp$$.bat
echo SET LADSOFT=%LADSOFT%>>C:\$$temp$$.bat
echo SET PATH=%%PATH%%;%LADSOFT%\BIN>>C:\$$temp$$.bat
echo REM>>c:\$$temp$$.bat
echo REM end LADSoft modification>>c:\$$temp$$.bat
echo REM>>c:\$$temp$$.bat
copy c:\autoexec.bat c:\autoexec.lad>nul
copy c:\autoexec.lad+c:\$$temp$$.bat c:\autoexec.bat
del c:\$$temp.bat>nul
goto nobat

:winnt3
  defs /R %LADSOFT% > q
echo.
echo Install has modified the registry.  You may need to reboot for the
echo changes to take effect
echo.

:nobat
echo.
echo Adding components to environment
echo.
SET LADSOFT=%LADSOFT%
SET PATH=%PATH%;%LADSOFT%\BIN
echo.
echo Installation complete
echo.
echo Read the file %LADSOFT%\README.TXT for general information on how to
echo get started.
echo. 

:exit